//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use super::sea_orm_active_enums::Protocol;
use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "Route")]
pub struct Model {
    #[sea_orm(primary_key, auto_increment = false)]
    pub id: Uuid,
    #[sea_orm(column_name = "proxyDomain", column_type = "Text")]
    pub proxy_domain: String,
    #[sea_orm(column_name = "enableCompression")]
    pub enable_compression: bool,
    #[sea_orm(column_name = "serviceId")]
    pub service_id: Uuid,
    #[sea_orm(column_name = "targetProtocol")]
    pub target_protocol: Protocol,
    #[sea_orm(column_name = "localPath", column_type = "Text")]
    pub local_path: String,
    #[sea_orm(column_name = "targetPath", column_type = "Text")]
    pub target_path: String,
    #[sea_orm(column_name = "targetPort")]
    pub target_port: i32,
    #[sea_orm(column_name = "allowInvalidCert")]
    pub allow_invalid_cert: bool,
    #[sea_orm(column_name = "targetSni", column_type = "Text", nullable)]
    pub target_sni: Option<String>,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(
        belongs_to = "super::proxy::Entity",
        from = "Column::ProxyDomain",
        to = "super::proxy::Column::Domain",
        on_update = "Cascade",
        on_delete = "Cascade"
    )]
    Proxy,
    #[sea_orm(
        belongs_to = "super::service::Entity",
        from = "Column::ServiceId",
        to = "super::service::Column::Id",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    Service,
}

impl Related<super::proxy::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Proxy.def()
    }
}

impl Related<super::service::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Service.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
